#include "highlighter.h"
#include <QtWidgets>

Highlighter::Highlighter(QTextDocument *parent)
    : QSyntaxHighlighter(parent)
{
    QFile file(":xml/color.xml" );

            if(file.open(QFile::ReadOnly | QFile::Text))
            {

                HighlightingRule rule;

                QTextCharFormat format;

                QRegularExpression pattern;

                xmlStream.setDevice(&file);

                   while(!xmlStream.atEnd() && !xmlStream.hasError())
                {
                    xmlStream.readNext();


                    if( xmlStream.isStartElement() )
                    {

                            if ( xmlStream.name() == "pattern" )
                            {

                             QRegularExpression reg(xmlStream.attributes().at(0).value().toString());

                             rule.pattern = reg;
                             qDebug()<<reg;

                             }


                              if ( xmlStream.name() == "format" )
                              {
                                 format.setForeground(QBrush(QColor((xmlStream.attributes().at(0).value().toString()))));

                                 qDebug()<<xmlStream.attributes().at(0).value().toString();

                                format.setFont(xmlStream.attributes().at(1).value().toString());

                                qDebug() << xmlStream.attributes().at(1).value().toString();

                                rule.format = format;

                                highlightingRules.push_back(rule);

                               }

                    }

               }
                   qDebug() <<" end iterration";
            }
            else
            {
                qDebug() <<" file doesnt open";
            }

            multiLineCommentFormat.setForeground(Qt::gray);

              commentStartExpression = QRegularExpression(QStringLiteral("/\\*"));
              commentEndExpression = QRegularExpression(QStringLiteral("\\*/"));
}


void Highlighter::highlightBlock(const QString &text)
{


    for (const HighlightingRule &rule : qAsConst(highlightingRules))
    {
        QRegularExpressionMatchIterator matchIterator = rule.pattern.globalMatch(text);
        while (matchIterator.hasNext()) {
            QRegularExpressionMatch match = matchIterator.next();
            setFormat(match.capturedStart(), match.capturedLength(), rule.format);
        }
    }
    setCurrentBlockState(0);

    int startIndex = 0;
       if (previousBlockState() != 1)
           startIndex = text.indexOf(commentStartExpression);

       while (startIndex >= 0) {
               QRegularExpressionMatch match = commentEndExpression.match(text, startIndex);
               int endIndex = match.capturedStart();
               int commentLength = 0;
               if (endIndex == -1) {
                   setCurrentBlockState(1);
                   commentLength = text.length() - startIndex;
               } else {
                   commentLength = endIndex - startIndex
                                   + match.capturedLength();
               }
               setFormat(startIndex, commentLength, multiLineCommentFormat);
               startIndex = text.indexOf(commentStartExpression, startIndex + commentLength);
           }

}












