#ifndef HIGHLIGHTER_H
#define HIGHLIGHTER_H


#include <QSyntaxHighlighter>
#include<QXmlStreamReader>
#include<QXmlAttributes>
#include <QXmlStreamAttribute>
#include <QXmlStreamAttributes>
#include<QRegularExpression>
#include<QBrush>
#include<QColor>
#include<QFile>



class Highlighter : public QSyntaxHighlighter
{
    Q_OBJECT

    public:

    Highlighter(QTextDocument *parent);

    QXmlStreamReader xmlStream;

    protected:
        void highlightBlock(const QString &text) override;

    private:
        struct HighlightingRule
        {
            QRegularExpression pattern;
            QTextCharFormat format;
        };

        QVector<HighlightingRule> highlightingRules;

        QRegularExpression commentStartExpression;
        QRegularExpression commentEndExpression;

        QTextCharFormat multiLineCommentFormat;

};



#endif // HIGHLIGHTER_H
